﻿Option Explicit On
Imports System.IO
Imports System.Windows.Forms
Imports System.Object
Imports DxfReader


Public Class Form1
    Dim AppTitle As String = "DXFファイルの解析(V1.0.1)"
    Public DxfDoc As New DxfReader.DxfReader
    Dim DxfOptions As New DxfReaderSettings
    Private tvMenu As ContextMenuStrip
    Dim fmFind As New FormFind
    Dim fmInfo As New FormInfo
    Dim StartNode As TreeNode
    Dim FoundNode As TreeNode
    Dim FoundElementIndex As Integer



    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butParsing.Click

        Dim openFileDialog1 As New OpenFileDialog()
        'Dim op1 As New DxfReaderSettings
        'Dim op2 As New DxfReaderSettings

        tbFileName.BackColor = Color.White

        openFileDialog1.InitialDirectory = My.Computer.FileSystem.CurrentDirectory
        openFileDialog1.Filter = "DXF files (*.dxf)|*.dxf|All files (*.*)|*.*"
        openFileDialog1.FilterIndex = 1
        openFileDialog1.RestoreDirectory = True

        If openFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            '
            txPrepareSection.Text = "解析中..."
            txPrepareSection.Update()

            tbFileName.Text = openFileDialog1.FileName
            Try
                DxfOptions.bCreateReportFile = cbReportFile.Checked
                If (rbTextCodeSjis.Checked = True) Then
                    DxfOptions.TextCode = DXF_TEXT_ENCODING.DXF_TEXT_CODE_SJIS
                End If
                If (rbTextCodeUtf8.Checked = True) Then
                    DxfOptions.TextCode = DXF_TEXT_ENCODING.DXF_TEXT_CODE_UTF8
                End If
                'DxfDoc.Create(openFileDialog1.FileName)
                Clean()
                tbFileName.Text = openFileDialog1.FileName
                tbFileName.Update()

                DxfDoc.Create2(openFileDialog1.FileName, DxfOptions)
                'txFileName.Text = DxfDoc.FileName
                'txFilePath.Text = DxfDoc.FilePath
                Dim mtime As String = DxfDoc.ModifiedTime
                txModifiedTime.Text = mtime
                txReportFileName.Text = DxfDoc.ReportFileName
                'txFilePath.Text = DxfDoc.ReportFilePath
                Dim pos As Integer = DxfDoc.FilePath.LastIndexOf(DxfDoc.FileName)
                My.Computer.FileSystem.CurrentDirectory = DxfDoc.FilePath.Remove(pos)



            Catch Ex As Exception
                MessageBox.Show("Cannot Create2: " & Ex.Message)
                tbFileName.BackColor = Color.LightPink
                Exit Sub
            End Try

            'Dxfファイルを正常に読み込んだ
            tbFileName.BackColor = Color.LightGreen
            InitSectionTree()
            CreateSectionTree()
            Me.Text = AppTitle + ":""" + DxfDoc.FileName + """"
            butOpenDXF.Enabled = True
            butReportFile.Enabled = True
        End If



    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Me.Text = AppTitle

        Init()

        cbReportFile.Checked = DxfOptions.bCreateReportFile
        rbTextCodeSjis.Checked = True
        rbTextCodeUtf8.Checked = False

        ' Create the ToolTip and associate with the Form container.
        Dim toolTip1 As New ToolTip()

        ' Set up the delays for the ToolTip.
        toolTip1.AutoPopDelay = 5000
        toolTip1.InitialDelay = 1000
        toolTip1.ReshowDelay = 500
        ' Force the ToolTip text to be displayed whether or not the form is active.
        toolTip1.ShowAlways = True

        ' Set up the ToolTip text for the Button and Checkbox.
        toolTip1.SetToolTip(Me.butParsing, "DXFファイルを読み込み解析します。")
        toolTip1.SetToolTip(Me.butOpenDXF, "DXFファイルをテキストエディタで開きます。")
        toolTip1.SetToolTip(Me.butReportFile, "解析結果のレポートファイルをテキストエディタで開きます。")
        toolTip1.SetToolTip(Me.butInfo, "ホームページからソースコードを取得できます。")

        butOpenDXF.Enabled = False
        butReportFile.Enabled = False


    End Sub

    Private Sub butClean_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butClean.Click
        Clean()

    End Sub
    Sub Clean()
        Me.Text = AppTitle
        InitSectionTree()
        InitProgress(10, 1)

        DxfDoc.Delete()

        tbFileName.Text = ""
        txReportFileName.Text = ""
        txModifiedTime.Text = ""
        tbFileName.Text = ""

        tbFileName.BackColor = Color.White

        butOpenDXF.Enabled = False
        butReportFile.Enabled = False

        tbFileName.Update()
        txReportFileName.Update()
        txModifiedTime.Update()


    End Sub

    Private Sub butReportFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butReportFile.Click
        If DxfDoc.ReportFilePath.Length() > 0 Then
            Dim command As String = "notepad " + DxfDoc.ReportFilePath
            Shell(command, AppWinStyle.NormalFocus)
        End If
    End Sub
    Sub InitSectionTree()
        ListView1.Items.Clear()

        tvSections.Nodes.Clear()
        Dim node0 As TreeNode = tvSections.Nodes.Add("SECTION")
        node0.Name = "ndSection"
        Dim node1 As TreeNode = node0.Nodes.Add("HEADER")
        node1.Name = "ndHeader"

        node1 = node0.Nodes.Add("TABLES")
        node1.Name = "ndTables"
        Dim node2 As TreeNode = node1.Nodes.Add("APPIDs")
        node2.Name = "ndAPPIDs"
        node2 = node1.Nodes.Add("BLOCK_RECORDs")
        node2.Name = "ndBLOCK_RECORDs"
        node2 = node1.Nodes.Add("DIMSTYLEs")
        node2.Name = "ndDIMSTYLEs"
        node2 = node1.Nodes.Add("LAYERs")
        node2.Name = "ndLAYERs"
        node2 = node1.Nodes.Add("LTYPEs")
        node2.Name = "ndLTYPEs"
        node2 = node1.Nodes.Add("STYLEs")
        node2.Name = "ndSTYLEs"
        node2 = node1.Nodes.Add("UCS")
        node2.Name = "ndUCSs"
        node2 = node1.Nodes.Add("VIEW")
        node2.Name = "ndVIEWs"
        node2 = node1.Nodes.Add("VPORTs")
        node2.Name = "ndVPORTs"

        node1 = node0.Nodes.Add("BLOCKS")
        node1.Name = "ndBlocks"
        node1 = node0.Nodes.Add("ENTITIES")
        node1.Name = "ndEntities"


        AddContextMenu()

    End Sub
    Sub CreateSectionTree()
        tvSections.Nodes.Item(0).Expand()
        Dim sections As DxfReader.DxfSections = DxfDoc.DxfSections

        tvSections.Nodes.Item(0).Tag = New TreeNodeData("SECTIONS", sections)
        tvSections.Nodes(0).Nodes("ndHeader").Tag = New TreeNodeData("SEC_HEADER", sections.HeaderSection)
        tvSections.Nodes(0).Nodes("ndTables").Tag = New TreeNodeData("SEC_TABLES", sections.TablesSection)
        tvSections.Nodes(0).Nodes("ndBlocks").Tag = New TreeNodeData("SEC_BLOCKS", sections.BlocksSection)


        'Exit Sub
        'TABLES
        txPrepareSection.Text = "TABLES..."
        InitProgress(9, 1)
        txPrepareSection.Update()
        Dim data As TreeNodeData
        Dim appids As DxfReader.DxfTables = sections.TablesSection.APPIDs
        'tvSections.Nodes(0).Nodes("ndTables").Nodes("ndAPPIDs").Tag = appids
        If appids.Count > 0 Then
            data = New TreeNodeData("TABLES", appids)
            tvSections.Nodes(0).Nodes("ndTables").Nodes("ndAPPIDs").Tag = data
            For Each appid As DxfReader.DxfTable In appids
                Dim name2 As String = GetTableName2(appid)
                Dim data1 As TreeNodeData = New TreeNodeData("TABLE", appid)
                Debug.Print("APPID:" + name2)
                Dim n As TreeNode = tvSections.Nodes(0).Nodes("ndTables").Nodes("ndAPPIDs").Nodes.Add(name2)
                n.Tag = data1
            Next
        End If
        IncrProgress()
        Dim brs As DxfReader.DxfTables = sections.TablesSection.BLOCK_RECORDs
        If brs.Count > 0 Then
            data = New TreeNodeData("TABLES", brs)
            tvSections.Nodes(0).Nodes("ndTables").Nodes("ndBLOCK_RECORDs").Tag = data
            For Each br As DxfReader.DxfTable In brs
                Dim name2 As String = GetTableName2(br)
                Dim data1 As TreeNodeData = New TreeNodeData("TABLE", br)
                Debug.Print("BLOCK_RECOR:" + name2)
                Dim n As TreeNode = tvSections.Nodes(0).Nodes("ndTables").Nodes("ndBLOCK_RECORDs").Nodes.Add(name2)
                n.Tag = data1
            Next

        End If
        IncrProgress()
        Dim dss As DxfReader.DxfTables = sections.TablesSection.DIMSTYLEs
        If dss.Count > 0 Then
            data = New TreeNodeData("TABLES", dss)
            tvSections.Nodes(0).Nodes("ndTables").Nodes("ndDIMSTYLEs").Tag = data
            For Each ds As DxfReader.DxfTable In dss
                Dim name2 As String = GetTableName2(ds)
                Dim data1 As TreeNodeData = New TreeNodeData("TABLE", ds)
                Debug.Print("DIMSTYLE:" + name2)
                Dim n As TreeNode = tvSections.Nodes(0).Nodes("ndTables").Nodes("ndDIMSTYLEs").Nodes.Add(name2)
                n.Tag = data1
            Next

        End If
        IncrProgress()
        Dim layers As DxfReader.DxfTables = sections.TablesSection.LAYERs
        If layers.Count > 0 Then
            data = New TreeNodeData("TABLES", layers)
            tvSections.Nodes(0).Nodes("ndTables").Nodes("ndLAYERs").Tag = data
            For Each layer As DxfReader.DxfTable In layers
                Dim name2 As String = GetTableName2(layer)
                Dim data1 As TreeNodeData = New TreeNodeData("TABLE", layer)
                Debug.Print("LAYER:" + name2)
                Dim n As TreeNode = tvSections.Nodes(0).Nodes("ndTables").Nodes("ndLAYERs").Nodes.Add(name2)
                n.Tag = data1
            Next

        End If
        IncrProgress()
        Dim ltypes As DxfReader.DxfTables = sections.TablesSection.LTYPEs
        If ltypes.Count > 0 Then
            data = New TreeNodeData("TABLES", ltypes)
            tvSections.Nodes(0).Nodes("ndTables").Nodes("ndLTYPEs").Tag = data
            For Each ltype As DxfReader.DxfTable In ltypes
                Dim name2 As String = GetTableName2(ltype)
                Dim data1 As TreeNodeData = New TreeNodeData("TABLE", ltype)
                Debug.Print("LTYPE:" + name2)
                Dim n As TreeNode = tvSections.Nodes(0).Nodes("ndTables").Nodes("ndLTYPEs").Nodes.Add(name2)
                n.Tag = data1
            Next

        End If
        IncrProgress()
        Dim styles As DxfReader.DxfTables = sections.TablesSection.STYLEs
        If styles.Count > 0 Then
            data = New TreeNodeData("TABLES", styles)
            tvSections.Nodes(0).Nodes("ndTables").Nodes("ndSTYLEs").Tag = data
            For Each style As DxfReader.DxfTable In styles
                Dim name2 As String = GetTableName2(style)
                Dim data1 As TreeNodeData = New TreeNodeData("TABLE", style)
                Debug.Print("STYLE:" + name2)
                Dim n As TreeNode = tvSections.Nodes(0).Nodes("ndTables").Nodes("ndSTYLEs").Nodes.Add(name2)
                n.Tag = data1
            Next

        End If
        IncrProgress()
        Dim ucss As DxfReader.DxfTables = sections.TablesSection.UCSs
        data = New TreeNodeData("TABLES", ucss)
        tvSections.Nodes(0).Nodes("ndTables").Nodes("ndUCSs").Tag = data
        If ucss.Count > 0 Then
            For Each ucs As DxfReader.DxfTable In ucss
                Dim name2 As String = GetTableName2(ucs)
                Dim data1 As TreeNodeData = New TreeNodeData("TABLE", ucs)
                Debug.Print("UCS:" + name2)
                Dim n As TreeNode = tvSections.Nodes(0).Nodes("ndTables").Nodes("ndUCSs").Nodes.Add(name2)
                n.Tag = data1
            Next

        End If
        IncrProgress()
        Dim views As DxfReader.DxfTables = sections.TablesSection.VIEWs
        data = New TreeNodeData("TABLES", views)
        tvSections.Nodes(0).Nodes("ndTables").Nodes("ndVIEWs").Tag = data
        If views.Count > 0 Then
            For Each view As DxfReader.DxfTable In views
                Dim name2 As String = GetTableName2(view)
                Dim data1 As TreeNodeData = New TreeNodeData("TABLE", view)
                Debug.Print("VIEW:" + name2)
                Dim n As TreeNode = tvSections.Nodes(0).Nodes("ndTables").Nodes("ndVIEWs").Nodes.Add(name2)
                n.Tag = data1
            Next

        End If
        IncrProgress()
        Dim vports As DxfReader.DxfTables = sections.TablesSection.VPORTs
        If vports.Count > 0 Then
            data = New TreeNodeData("TABLES", vports)
            tvSections.Nodes(0).Nodes("ndTables").Nodes("ndVPORTs").Tag = data
            For Each vport As DxfReader.DxfTable In vports
                Dim name2 As String = GetTableName2(vport)
                Dim data1 As TreeNodeData = New TreeNodeData("TABLE", vport)
                Debug.Print("VPORT:" + name2)
                Dim n As TreeNode = tvSections.Nodes(0).Nodes("ndTables").Nodes("ndVPORTs").Nodes.Add(name2)
                n.Tag = data1
            Next

        End If
        IncrProgress()
        'BLOCKS
        txPrepareSection.Text = "BLOCKS..."
        txPrepareSection.Update()
        Dim blocks As DxfReader.DxfBlocks = sections.BlocksSection.DxfBlocks
        InitProgress(blocks.Count, 1)
        For Each block As DxfBlock In blocks
            Dim name2 As String = GetBlockName2(block)
            Dim data1 As TreeNodeData = New TreeNodeData("BLOCK", block)
            'Debug.Print("BLOCK:" + name2)
            Dim ndBlock As TreeNode = tvSections.Nodes(0).Nodes("ndBlocks").Nodes.Add(name2)
            ndBlock.Tag = data1
            For Each entity As DxfEntity In block.DxfEntities
                Dim EntityType As String = entity.EntityType
                Dim data2 As TreeNodeData = New TreeNodeData("ENTITY", entity)
                'Debug.Print("ENTITY:" + EntityType)
                Dim ndEntity As TreeNode = ndBlock.Nodes.Add(EntityType)
                ndEntity.Tag = data2

            Next
            IncrProgress()
        Next
        'ENTITIES
        txPrepareSection.Text = "ENTITIES..."
        txPrepareSection.Update()
        Dim Entities As DxfReader.DxfEntities = sections.EntitiesSection.DxfEntities
        InitProgress(Entities.Count, 1)
        For Each entity As DxfEntity In Entities
            Dim EntityType As String = entity.EntityType
            Dim data2 As TreeNodeData = New TreeNodeData("ENTITY", entity)
            'Debug.Print("ENTITY:" + EntityType)
            Dim ndEntity As TreeNode = tvSections.Nodes(0).Nodes("ndEntities").Nodes.Add(EntityType)
            ndEntity.Tag = data2

            IncrProgress()
        Next
        txPrepareSection.Text = "成功"
        txPrepareSection.Update()

    End Sub

    Private Sub tvSections_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvSections.AfterSelect
        Dim sections As DxfReader.DxfSections = DxfDoc.DxfSections
        ListView1.Items.Clear()
        ListView1.Columns.Clear()
        Dim data As TreeNodeData
        Select Case e.Node.Name
            Case "ndSection"
                data = e.Node.Tag
            Case "ndHeader"
                data = e.Node.Tag
                If sections.HeaderSection.Variables.Count > 0 Then
                    DumpHeaderSection(sections.HeaderSection)
                End If
            Case "ndTables"
                data = e.Node.Tag
            Case Else
                data = e.Node.Tag
                If (data IsNot Nothing) Then
                    Select Case data.DataType
                        Case "TABLE"
                            Dim table As DxfTable = data.DxfData
                            DumpTableElements(table)
                        Case "TABLES"
                            Dim tables As DxfTables = data.DxfData
                            DumpTablesElements(tables)
                        Case "BLOCK"
                            Dim block As DxfBlock = data.DxfData
                            DumpBlock(block)
                        Case "ENTITY"
                            Dim entity As DxfEntity = data.DxfData
                            DumpEntity(entity)
                    End Select

                End If
        End Select

    End Sub



    Sub DumpHeaderSection(ByRef header As DxfReader.DxfHeaderSection)
        Debug.Print("Header elements")
        ListView1.Columns.Add("NAME")
        ListView1.Columns.Add("VALUE1")
        ListView1.Columns.Add("VALUE2")
        ListView1.Columns.Add("VALUE3")
        ListView1.Columns.Item(0).Width = 150
        ListView1.Columns.Item(1).Width = 100
        Dim count As Integer = header.Variables.Count
        For Each var As DxfReader.DxfVariable In header.Variables
            'Debug.Print(var.Name)
            Dim item1 As New ListViewItem(var.Name, 0)
            ' Place a check mark next to the item.
            Dim i As Integer = 0
            For Each element As DxfElement In var.DxfElements
                item1.SubItems.Add(element.Value)
                i += 1
                If (i = 3) Then
                    Exit For
                End If
            Next
            ListView1.Items.Add(item1)
        Next

    End Sub
    Sub DumpTableElements(ByRef table As DxfTable)
        If (table.DxfElements.Count > 0) Then
            Debug.Print("Table elements")
            ListView1.Columns.Add("GroupCode")
            ListView1.Columns.Add("VALUE")
            ListView1.Columns.Item(1).Width = 150
            For Each element As DxfElement In table.DxfElements
                Dim item1 As New ListViewItem(element.GroupCode.ToString, 0)
                item1.SubItems.Add(element.Value)
                ListView1.Items.Add(item1)
            Next
        End If

    End Sub
    Sub DumpTablesElements(ByRef tables As DxfTables)
        If (tables.DxfElements.Count > 0) Then
            Debug.Print("Tables elements")
            ListView1.Columns.Add("GroupCode")
            ListView1.Columns.Add("VALUE")
            ListView1.Columns.Item(1).Width = 150
            For Each element As DxfElement In tables.DxfElements
                Dim item1 As New ListViewItem(element.GroupCode.ToString, 0)
                item1.SubItems.Add(element.Value)
                ListView1.Items.Add(item1)
            Next
        End If

    End Sub
    Sub DumpBlock(ByRef block As DxfBlock)
        Debug.Print("Block elements")
        ListView1.Columns.Add("GroupCode")
        ListView1.Columns.Add("VALUE")
        ListView1.Columns.Item(1).Width = 150
        If (block.DxfElements.Count > 0) Then
            ListView1.Items.Add("BLOCK")
            For Each element As DxfElement In block.DxfElements
                Dim item1 As New ListViewItem(element.GroupCode.ToString, 0)
                item1.SubItems.Add(element.Value)
                ListView1.Items.Add(item1)
            Next

        End If
        If (block.DxfElements2.Count > 0) Then
            ListView1.Items.Add("ENDBLK")
            For Each element As DxfElement In block.DxfElements2
                Dim item1 As New ListViewItem(element.GroupCode.ToString, 0)
                item1.SubItems.Add(element.Value)
                ListView1.Items.Add(item1)
            Next

        End If
    End Sub
    Sub DumpEntity(ByVal entity As DxfEntity)
        Debug.Print("Entity elements")
        ListView1.Columns.Add("GroupCode")
        ListView1.Columns.Add("VALUE")
        ListView1.Columns.Item(1).Width = 150
        If (entity.DxfElements.Count > 0) Then
            For Each element As DxfElement In entity.DxfElements
                Dim item1 As New ListViewItem(element.GroupCode.ToString, 0)
                item1.SubItems.Add(element.Value)
                ListView1.Items.Add(item1)
            Next

        End If

    End Sub

    Function GetTableName2(ByRef table As DxfTable) As String
        Dim name2 As String
        Dim element As DxfElement = table.DxfElements.Item(2)
        If (element IsNot Nothing) Then
            name2 = element.Value
        Else
            name2 = "?"
        End If
        Return name2
    End Function



    Function GetBlockName2(ByRef block As DxfBlock) As String
        Dim name2 As String
        Dim element As DxfElement = block.DxfElements.Item(2)
        If (element IsNot Nothing) Then
            name2 = element.Value
        Else
            name2 = "?"
        End If
        Return name2
    End Function


    Private Sub butOpenDXF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butOpenDXF.Click
        If DxfDoc.FileName.Length() > 0 Then
            Dim command As String = "notepad " + DxfDoc.FilePath
            Shell(command, AppWinStyle.NormalFocus)
        End If

    End Sub


    Sub InitProgress(ByVal Max As Integer, ByVal incr As Integer)
        If (Max > 0) Then
            ProgressBar1.Visible = True
            ' Set Minimum to 1 to represent the first file being copied.
            ProgressBar1.Minimum = 1
            ' Set Maximum to the total number of files to copy.
            ProgressBar1.Maximum = Max
            ' Set the initial value of the ProgressBar.
            ProgressBar1.Value = 1
            ' Set the Step property to a value of 1 to represent each file being copied.
            ProgressBar1.Step = incr
        End If
    End Sub
    Sub IncrProgress()
        ProgressBar1.PerformStep()
    End Sub

    Sub AddContextMenu()
        ' Create the ContextMenuStrip.
        tvMenu = New ContextMenuStrip()

        'Create some menu items.
        Dim openLabel As New ToolStripMenuItem()
        openLabel.Text = "Open"
        Dim deleteLabel As New ToolStripMenuItem()
        deleteLabel.Text = "Delete"
        Dim renameLabel As New ToolStripMenuItem()
        renameLabel.Text = "Rename"

        'Add the menu items to the menu.
        tvMenu.Items.AddRange(New ToolStripMenuItem() _
            {openLabel, deleteLabel, renameLabel})

        ' Set the ContextMenuStrip property to the ContextMenuStrip.
        tvSections.Nodes.Item(0).ContextMenuStrip = tvMenu


    End Sub

    Private Sub butFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butFind.Click
        fmFind.Show()

    End Sub
    Public Function FindTextInSelectedNode(ByVal options As FindData, ByRef results As Collection) As String
        Dim path As String
        Dim start As TreeNode
        FoundNode = Nothing
        FoundElementIndex = -1
        start = tvSections.SelectedNode
        StartNode = start
        If (start IsNot Nothing) Then
            path = start.Text
            Dim found As Integer = FindWordInNodes(start, path, options, results)
            If (found > 0) Then
                Return "見つかりました。"
            Else
                Return "見つかりませんでした。"
            End If
        End If
        Return "検索するツリーノードを選択してください。"
    End Function
    Public Function FindTextFromTop(ByVal options As FindData, ByRef results As Collection) As String
        Dim path As String
        Dim start As TreeNode
        FoundNode = Nothing
        FoundElementIndex = -1
        start = tvSections.Nodes.Item(0)
        StartNode = start
        If (start IsNot Nothing) Then
            path = start.Text
            Dim found As Integer = FindWordInNodes(start, path, options, results)
            If (found > 0) Then
                Return "見つかりました。"
            Else
                Return "見つかりませんでした。"
            End If
        End If
        Return "検索するツリーノードを選択してください。"
    End Function
    Function FindWordInNodes(ByVal nodeFind As TreeNode, ByVal path As String, ByVal options As FindData, ByRef results As Collection) As Integer
        If (nodeFind.Nodes.Count > 0) Then
            For Each node As TreeNode In nodeFind.Nodes
                Dim new_path As String = path + "/" + node.Text
                If CompareString(node.Text, options.word, options.bPartialMatch, options.bNoCase) Then
                    FoundNode = node
                    Dim data As FindResultData = New FindResultData(new_path, node)
                    results.Add(data)
                End If
                If (node.Nodes.Count > 0) Then
                    Dim c As Integer = FindWordInNodes(node, new_path, options, results)
                Else
                    'LISTVIEW
                    Dim c As Integer = FindValue(node, new_path, options, results)
                End If
            Next
        Else
            'LISTVIEW
            Dim c As Integer = FindValue(nodeFind, path, options, results)
        End If
        Return results.Count
    End Function
    Function FindWordInListView(ByVal word As String, ByVal FromTop As Boolean, ByVal part As Boolean, ByVal nocase As Boolean) As Integer
        For i As Integer = 0 To ListView1.Items.Count - 1
            If (ListView1.Items(i).Text = word) Then
                Return i
            End If
            For j As Integer = 0 To ListView1.Items(i).SubItems.Count - 1
                If (ListView1.Items(i).SubItems(j).Text = word) Then
                    Return i
                End If
            Next
        Next
        Return -1
    End Function
    Function FindValue(ByVal node As TreeNode, ByVal path As String, ByVal options As FindData, ByRef results As Collection) As Integer
        Dim data As TreeNodeData = node.Tag
        Dim index As Integer = 0
        If (data IsNot Nothing) Then
            Select Case data.DataType
                Case "SEC_HEADER"
                    Dim sec As DxfHeaderSection = data.DxfData
                    For Each var As DxfVariable In sec.Variables
                        If CompareString(var.Name, options.word, options.bPartialMatch, options.bNoCase) Then
                            Dim found As FindResultData = New FindResultData(path, node)
                            found.index = index
                            'found.GroupCode = Val.GroupCode
                            found.Value = var.Name
                            results.Add(found)
                        End If
                        index += 1
                    Next
                Case "TABLE"
                    Dim table As DxfTable = data.DxfData
                    For Each el As DxfElement In table.DxfElements
                        If FilterElement(el, options) Then
                            Dim found As FindResultData = New FindResultData(path, node)
                            found.index = index
                            found.GroupCode = el.GroupCode
                            found.Value = el.Value
                            results.Add(found)
                        End If
                        index += 1
                    Next
                Case "BLOCK"
                    Dim block As DxfBlock = data.DxfData
                    For Each el As DxfElement In block.DxfElements
                        If FilterElement(el, options) Then
                            Dim found As FindResultData = New FindResultData(path, node)
                            found.index = index
                            found.GroupCode = el.GroupCode
                            found.Value = el.Value
                            results.Add(found)
                        End If
                        index += 1
                    Next
                Case "ENTITY"
                    Dim entity As DxfEntity = data.DxfData
                    For Each el As DxfElement In entity.DxfElements
                        If FilterElement(el, options) Then
                            Dim found As FindResultData = New FindResultData(path, node)
                            found.index = index
                            found.GroupCode = el.GroupCode
                            found.Value = el.Value
                            results.Add(found)
                        End If
                        index += 1
                    Next
            End Select

        End If
        Return index
    End Function
    Function FilterElement(ByVal el As DxfElement, ByVal options As FindData) As Integer
        If (options.GroupCode <= 0) Then
            Return CompareString(el.Value, options.word, options.bPartialMatch, options.bNoCase)
        Else
            If (el.GroupCode = options.GroupCode) Then
                Return CompareString(el.Value, options.word, options.bPartialMatch, options.bNoCase)
            End If
        End If
    End Function

    Function CompareString(ByVal text As String, ByVal word As String, ByVal part As Boolean, ByVal nocase As Boolean) As Boolean
        If (part) Then
            If (nocase) Then
                Return text.ToLower().Contains(word.ToLower())
            Else
                Return text.Contains(word)
            End If
        Else
            Return String.Compare(text, word, nocase) = 0
        End If
    End Function

    Private Sub butInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butInfo.Click
        fmInfo.Show()
    End Sub
End Class
